"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var MongooseModel_1 = require("../MongooseModel");
var MultiTenant = /** @class */ (function () {
    function MultiTenant(mongoose) {
        this.mongoose = mongoose;
        this.models = {};
    }
    MultiTenant.prototype.tenantModel = function (name, schema, options) {
        var _this = this;
        return function (props) {
            if (props === void 0) { props = {}; }
            var skipBrand = props.skipBrand;
            var mongooseModel = new MongooseModel_1.MongooseModel(_this.mongoose);
            return mongooseModel.createModel(name, schema, options, _this.models, skipBrand);
        };
    };
    MultiTenant.prototype.tenantlessModel = function (name, schema, options) {
        var _this = this;
        return function () { return _this.mongoose.model(name, schema, options); };
    };
    return MultiTenant;
}());
exports.default = MultiTenant;
