"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMongooseProviders = void 0;
var MongooseModel_1 = require("../MongooseModel");
function createMongooseProviders(connectionName, models) {
    if (models === void 0) { models = []; }
    var providers = (models || []).map(function (model) { return ({
        provide: model.name + "Model",
        useFactory: function (connection) {
            var mongooseModel = new MongooseModel_1.MongooseModel(connection);
            return mongooseModel.createModel(model.name, model.schema, model.collection, {});
        },
        inject: [connectionName + "Connection"],
    }); });
    return providers;
}
exports.createMongooseProviders = createMongooseProviders;
